commit cb89f4f7e3766c95635f684be724a814c6ae5281
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Wed Jul 24 20:10:11 2019 +0200

    ref #6794  adapt TaxEditor to new term structure (rename FeatureNode and FeatureTree)

diff --git a/eu.etaxonomy.taxeditor.cdmlib/src/main/java/eu/etaxonomy/cdm/api/application/CdmApplicationRemoteConfiguration.java b/eu.etaxonomy.taxeditor.cdmlib/src/main/java/eu/etaxonomy/cdm/api/application/CdmApplicationRemoteConfiguration.java
index 778431f3c..dcd95054c 100644
--- a/eu.etaxonomy.taxeditor.cdmlib/src/main/java/eu/etaxonomy/cdm/api/application/CdmApplicationRemoteConfiguration.java
+++ b/eu.etaxonomy.taxeditor.cdmlib/src/main/java/eu/etaxonomy/cdm/api/application/CdmApplicationRemoteConfiguration.java
@@ -45,6 +45,7 @@ import eu.etaxonomy.cdm.api.service.ICollectionService;
 import eu.etaxonomy.cdm.api.service.ICommonService;
 import eu.etaxonomy.cdm.api.service.IDatabaseService;
 import eu.etaxonomy.cdm.api.service.IDescriptionService;
+import eu.etaxonomy.cdm.api.service.IDescriptiveDataSetService;
 import eu.etaxonomy.cdm.api.service.IEntityConstraintViolationService;
 import eu.etaxonomy.cdm.api.service.IEntityValidationService;
 import eu.etaxonomy.cdm.api.service.IEventBaseService;
@@ -65,20 +66,19 @@ import eu.etaxonomy.cdm.api.service.IProgressMonitorService;
 import eu.etaxonomy.cdm.api.service.IReferenceService;
 import eu.etaxonomy.cdm.api.service.IRegistrationService;
 import eu.etaxonomy.cdm.api.service.IRightsService;
-import eu.etaxonomy.cdm.api.service.IService;
 import eu.etaxonomy.cdm.api.service.ITaxonNodeService;
 import eu.etaxonomy.cdm.api.service.ITaxonService;
+import eu.etaxonomy.cdm.api.service.ITermNodeService;
 import eu.etaxonomy.cdm.api.service.ITermService;
+import eu.etaxonomy.cdm.api.service.ITermTreeService;
 import eu.etaxonomy.cdm.api.service.ITestService;
 import eu.etaxonomy.cdm.api.service.IUserService;
 import eu.etaxonomy.cdm.api.service.IVocabularyService;
-import eu.etaxonomy.cdm.api.service.IDescriptiveDataSetService;
 import eu.etaxonomy.cdm.api.service.molecular.IAmplificationService;
 import eu.etaxonomy.cdm.api.service.molecular.IPrimerService;
 import eu.etaxonomy.cdm.api.service.molecular.ISequenceService;
 import eu.etaxonomy.cdm.ext.geo.IEditGeoService;
 import eu.etaxonomy.cdm.io.service.IIOService;
-import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.persistence.hibernate.permission.CdmPermissionEvaluator;
 import eu.etaxonomy.cdm.persistence.hibernate.permission.ICdmPermissionEvaluator;
 import eu.etaxonomy.cdm.persistence.hibernate.permission.UnanimousBasedUnrevokable;
@@ -375,11 +375,20 @@ public class CdmApplicationRemoteConfiguration implements ICdmRepository, Applic
     public IFeatureTreeService getFeatureTreeService(){
         return (IFeatureTreeService) getService(IFeatureTreeService.class, "/remoting/featuretree.service", new CdmServiceRequestExecutor());
     }
+    @Override
+    public ITermTreeService getTermTreeService() {
+    	return (ITermTreeService) getService(ITermTreeService.class, "/remoting/termtree.service", new CdmServiceRequestExecutor());
+    }
 
     @Override
     public IFeatureNodeService getFeatureNodeService(){
         return (IFeatureNodeService) getService(IFeatureNodeService.class, "/remoting/featurenode.service", new CdmServiceRequestExecutor());
     }
+    
+	@Override
+	public ITermNodeService getTermNodeService() {
+        return (ITermNodeService) getService(ITermNodeService.class, "/remoting/termnode.service", new CdmServiceRequestExecutor());
+	}
 
     @Override
     public IVocabularyService getVocabularyService(){
@@ -499,4 +508,6 @@ public class CdmApplicationRemoteConfiguration implements ICdmRepository, Applic
     public ITestService getTestService() {
         return (ITestService) getService(ITestService.class, "/remoting/test.service", new CdmServiceRequestExecutor());
     }
+
+
 }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetComposite.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetComposite.java
index fcb0a3195..e6ae0ab87 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetComposite.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetComposite.java
@@ -22,10 +22,10 @@ import org.eclipse.swt.widgets.Label;
 import org.eclipse.swt.widgets.Text;
 import org.eclipse.swt.widgets.Tree;
 
-import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.model.description.Character;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.term.TermTree;
+import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.persistence.dto.TermDto;
 import eu.etaxonomy.cdm.remote.l10n.TermRepresentation_L10n;
 import eu.etaxonomy.taxeditor.editor.l10n.Messages;
@@ -165,10 +165,10 @@ public class DescriptiveDataSetComposite extends Composite {
         return featureTreeEditorComposite;
     }
 
-    public FeatureTree<Character> getCharacters(){
+    public TermTree<Character> getCharacters(){
         return featureTreeEditorComposite.getFeatureTree();
     }
-    public void setCharacters(FeatureTree<Character> characters) {
+    public void setCharacters(TermTree<Character> characters) {
         featureTreeEditorComposite.setSelectedTree(characters);
     }
 
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetEditor.java
index 66011b2e0..00553008b 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetEditor.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/DescriptiveDataSetEditor.java
@@ -64,7 +64,7 @@ import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.taxon.ITaxonTreeNode;
 import eu.etaxonomy.cdm.model.taxon.TaxonNode;
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.persistence.dto.TaxonNodeDto;
 import eu.etaxonomy.cdm.persistence.dto.TermDto;
@@ -289,10 +289,10 @@ IPartContentHasDetails, IPartContentHasSupplementalData, IDirtyMarkable {
                 }
             }
         }
-        FeatureTree<Character> characters = composite.getCharacters();
+        TermTree<Character> characters = composite.getCharacters();
         if(characters!=null){
             //save characters because they can be modified in this editor
-            characters.getDistinctFeatures().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
+            characters.getDistinctTerms().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
         }
 
 
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDragListener.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDragListener.java
index 874b8eff6..f183b56e1 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDragListener.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDragListener.java
@@ -22,7 +22,7 @@ import org.eclipse.swt.graphics.Point;
 import org.eclipse.swt.widgets.Display;
 
 import eu.etaxonomy.cdm.model.description.Character;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
+import eu.etaxonomy.cdm.model.term.TermNode;
 import eu.etaxonomy.taxeditor.featuretree.CharacterTransfer;
 import eu.etaxonomy.taxeditor.featuretree.e4.FeatureNodeDragListener;
 
@@ -72,9 +72,9 @@ public class CharacterDragListener extends FeatureNodeDragListener {
                 !structureViewer.getSelection().isEmpty()
                 && !propertyViewer.getSelection().isEmpty()
                 && ((IStructuredSelection) structureViewer.getSelection()).toList()
-                .stream().allMatch(element -> element instanceof FeatureNode)
+                .stream().allMatch(element -> element instanceof TermNode)
                 && ((IStructuredSelection) propertyViewer.getSelection()).toList()
-                .stream().allMatch(element -> element instanceof FeatureNode);
+                .stream().allMatch(element -> element instanceof TermNode);
         if(!event.doit){
             return;
         }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDropAdapter.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDropAdapter.java
index 9e733912d..956b86343 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDropAdapter.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterDropAdapter.java
@@ -15,8 +15,9 @@ import org.eclipse.swt.dnd.TransferData;
 
 import eu.etaxonomy.cdm.api.service.IFeatureNodeService;
 import eu.etaxonomy.cdm.model.description.Character;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.featuretree.CharacterTransfer;
 import eu.etaxonomy.taxeditor.featuretree.e4.FeatureTreeDropAdapter;
 import eu.etaxonomy.taxeditor.store.CdmStore;
@@ -39,7 +40,7 @@ public class CharacterDropAdapter extends FeatureTreeDropAdapter {
 
 	@Override
 	protected Object determineTarget(DropTargetEvent event) {
-        return event.item == null ? ((FeatureTree)getViewer().getInput()).getRoot() : event.item.getData();
+        return event.item == null ? ((TermTree<Feature>)getViewer().getInput()).getRoot() : event.item.getData();
 	}
 
 	@Override
@@ -53,7 +54,7 @@ public class CharacterDropAdapter extends FeatureTreeDropAdapter {
 	    if(!characterEditor.isVocabularySet()){
 	        return false;
 	    }
-	    FeatureNode target = (FeatureNode) getCurrentTarget();
+	    TermNode<Feature> target = (TermNode<Feature>) getCurrentTarget();
 	    if(data instanceof Object[]){
 	        Object[] transferObjects = (Object[])data;
 	        for(int i=0;i<transferObjects.length;i++){
@@ -62,7 +63,7 @@ public class CharacterDropAdapter extends FeatureTreeDropAdapter {
 	                Character character = (Character)object;
 	                if(target==null){
                         //drop on feature tree
-                        target = ((FeatureTree)getViewer().getInput()).getRoot();
+                        target = ((TermTree<Feature>)getViewer().getInput()).getRoot();
                     }
                     CdmStore.getService(IFeatureNodeService.class).createChildFeatureNode(target.getUuid(), character, characterEditor.getVocabulary().getUuid());
 	            }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterEditor.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterEditor.java
index 0c549f6be..212ce6d46 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterEditor.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/character/CharacterEditor.java
@@ -59,10 +59,11 @@ import eu.etaxonomy.cdm.api.service.IFeatureTreeService;
 import eu.etaxonomy.cdm.api.service.ITermService;
 import eu.etaxonomy.cdm.api.service.IVocabularyService;
 import eu.etaxonomy.cdm.model.description.Character;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
 import eu.etaxonomy.cdm.model.term.Representation;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermType;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.cdm.model.term.VocabularyEnum;
@@ -226,7 +227,7 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
                     return;
                 }
                 Collection<Character> characters = createCharacters((TreeSelection)structureTreeSelection, (TreeSelection)propertyTreeSelection);
-                FeatureNode<Character> parent = ((FeatureTree<Character>) characterTreeEditorComposite.getViewer().getInput()).getRoot();
+                TermNode<Character> parent = ((TermTree<Character>) characterTreeEditorComposite.getViewer().getInput()).getRoot();
                 for (Character character : characters) {
                     //add new Character to feature tree
                     CdmStore.getService(IFeatureNodeService.class).createChildFeatureNode(parent.getUuid(), character, vocabulary.getUuid());
@@ -291,14 +292,14 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
     public static Collection<Character> createCharacters(TreeSelection structureTreeSelection, TreeSelection propertyTreeSelection){
         Set<Character> characters = new HashSet<>();
         //get selected structures and properties
-        Iterator<FeatureNode<DefinedTermBase>> structureIterator = structureTreeSelection.iterator();
+        Iterator<TermNode<DefinedTermBase>> structureIterator = structureTreeSelection.iterator();
 
         //create all combinations of structures and properties
         while(structureIterator.hasNext()){
-            FeatureNode<DefinedTermBase> structureNode = structureIterator.next();
-            Iterator<FeatureNode<DefinedTermBase>> propertiesIterator = propertyTreeSelection.iterator();
+            TermNode<DefinedTermBase> structureNode = structureIterator.next();
+            Iterator<TermNode<DefinedTermBase>> propertiesIterator = propertyTreeSelection.iterator();
             while(propertiesIterator.hasNext()){
-                FeatureNode<DefinedTermBase> propertyNode = propertiesIterator.next();
+                TermNode<DefinedTermBase> propertyNode = propertiesIterator.next();
                 Representation structureRepresentation = structureNode.getTerm().getRepresentation(PreferencesUtil.getGlobalLanguage());
                 Representation propertyRepresentation = propertyNode.getTerm().getRepresentation(PreferencesUtil.getGlobalLanguage());
                 String label = null;
@@ -327,10 +328,10 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
         // commit the conversation and start a new transaction immediately
         conversation.commit(true);
 
-        FeatureTree<Character> featureTree = characterTreeEditorComposite.getFeatureTree();
+        TermTree<Character> featureTree = characterTreeEditorComposite.getFeatureTree();
         if(featureTree!=null){
             //save characters because they can be modified in this editor
-            featureTree.getDistinctFeatures().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
+            featureTree.getDistinctTerms().forEach(character->CdmStore.getService(ITermService.class).merge(character,true));
         }
         CdmStore.getService(IFeatureTreeService.class).saveOrUpdate(featureTree);
 
@@ -376,13 +377,13 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
         });
         Map<Object, List<String>> propertyPathMap =
                 new HashMap<Object, List<String>>();
-        propertyPathMap.put(FeatureNode.class,propertyPaths);
+        propertyPathMap.put(TermNode.class,propertyPaths);
         return propertyPathMap;
     }
 
     @Override
-    public List<FeatureTree<Character>> getRootEntities() {
-        List<FeatureTree<Character>> root = new ArrayList<>();
+    public List<TermTree<Character>> getRootEntities() {
+        List<TermTree<Character>> root = new ArrayList<>();
         root.add(characterTreeEditorComposite.getFeatureTree());
         return root;
     }
@@ -422,7 +423,7 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
         return (IStructuredSelection) characterTreeEditorComposite.getViewer().getSelection();
     }
 
-    public FeatureTree<Character> getCharacterTree(){
+    public TermTree<Character> getCharacterTree(){
         return characterTreeEditorComposite.getFeatureTree();
     }
 
@@ -434,10 +435,10 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
     }
 
     private class FeatureTreeChooserListener extends SelectionAdapter{
-        private FeatureTreeEditorComposite<?> featureTreeEditorComposite;
+        private FeatureTreeEditorComposite<Feature> featureTreeEditorComposite;
         private TermType termType;
 
-        public FeatureTreeChooserListener(FeatureTreeEditorComposite<?> featureTreeEditorComposite, TermType termType) {
+        public FeatureTreeChooserListener(FeatureTreeEditorComposite<Feature> featureTreeEditorComposite, TermType termType) {
             super();
             this.featureTreeEditorComposite = featureTreeEditorComposite;
             this.termType = termType;
@@ -445,7 +446,7 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
 
         @Override
         public void widgetSelected(SelectionEvent e) {
-            FeatureTree tree = FeatureTreeSelectionDialog.select(featureTreeEditorComposite.getDisplay().getActiveShell(), null, termType);
+            TermTree<Feature> tree = FeatureTreeSelectionDialog.select(featureTreeEditorComposite.getDisplay().getActiveShell(), null, termType);
             if(tree!=null){
                 featureTreeEditorComposite.setSelectedTree(tree);
             }
@@ -475,7 +476,7 @@ public class CharacterEditor implements IFeatureTreeEditor,IConversationEnabled,
     @Override
     public boolean postOperation(Object objectAffectedByOperation) {
         characterTreeEditorComposite.getViewer().refresh();
-        if(objectAffectedByOperation instanceof FeatureNode){
+        if(objectAffectedByOperation instanceof TermNode){
             StructuredSelection selection = new StructuredSelection(objectAffectedByOperation);
             characterTreeEditorComposite.getViewer().setSelection(selection);
         }
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/matrix/CharacterMatrix.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/matrix/CharacterMatrix.java
index 6e96a0a12..0ed4e1265 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/matrix/CharacterMatrix.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/descriptiveDataSet/matrix/CharacterMatrix.java
@@ -105,8 +105,8 @@ import eu.etaxonomy.cdm.model.description.DescriptiveDataSet;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.MeasurementUnit;
 import eu.etaxonomy.cdm.model.description.State;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.TermVocabulary;
 import eu.etaxonomy.cdm.persistence.dto.SpecimenNodeWrapper;
 import eu.etaxonomy.cdm.persistence.dto.TermDto;
@@ -277,7 +277,7 @@ public class CharacterMatrix extends Composite {
         getNatTableState().remove(PersistenceDialog.ACTIVE_VIEW_CONFIGURATION_KEY);
     }
 
-    private List<Character> initCharacterList(FeatureNode<Character> node){
+    private List<Character> initCharacterList(TermNode<Character> node){
         List<Character> characters = new ArrayList<>();
         node.getChildNodes().forEach(childNode->
                 {
@@ -290,7 +290,7 @@ public class CharacterMatrix extends Composite {
     public void initDescriptiveDataSet(DescriptiveDataSet descriptiveDataSet){
         this.descriptiveDataSet = descriptiveDataSet;
         //get features/columns stored in descriptive data set
-        FeatureTree<Character> tree = descriptiveDataSet.getDescriptiveSystem();
+        TermTree<Character> tree = descriptiveDataSet.getDescriptiveSystem();
         characters = initCharacterList(tree.getRoot());
 
         //init state data for categorical features
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/DescriptiveContentProvider.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/DescriptiveContentProvider.java
index 9cf54bb45..25f619d56 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/DescriptiveContentProvider.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/DescriptiveContentProvider.java
@@ -17,10 +17,11 @@ import org.eclipse.jface.viewers.Viewer;
 import eu.etaxonomy.cdm.model.common.Marker;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.IDescribable;
 import eu.etaxonomy.cdm.model.description.IndividualsAssociation;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.taxeditor.editor.definedterm.input.TermEditorInput;
 import eu.etaxonomy.taxeditor.model.FeatureNodeContainer;
 import eu.etaxonomy.taxeditor.model.FeatureNodeContainerTree;
@@ -181,9 +182,9 @@ public class DescriptiveContentProvider implements ITreeContentProvider {
 	 * @param description
 	 * @return
 	 */
-	private FeatureTree getFeatureTree(DescriptionBase description){
+	private TermTree<Feature> getFeatureTree(DescriptionBase description){
 
-	        FeatureTree<?> featureTree = null;
+	        TermTree<Feature> featureTree = null;
 
 	        // TODO change this to the feature tree associated with this taxon
 	        // description
diff --git a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/e4/handler/DynamicFeatureMenuE4.java b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/e4/handler/DynamicFeatureMenuE4.java
index 950497bfb..25e412686 100644
--- a/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/e4/handler/DynamicFeatureMenuE4.java
+++ b/eu.etaxonomy.taxeditor.editor/src/main/java/eu/etaxonomy/taxeditor/editor/view/descriptive/e4/handler/DynamicFeatureMenuE4.java
@@ -31,8 +31,8 @@ import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.term.DefinedTermBase;
-import eu.etaxonomy.cdm.model.term.FeatureNode;
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermNode;
+import eu.etaxonomy.cdm.model.term.TermTree;
 import eu.etaxonomy.cdm.model.term.VocabularyEnum;
 import eu.etaxonomy.taxeditor.editor.definedterm.input.TermEditorInput;
 import eu.etaxonomy.taxeditor.editor.l10n.Messages;
@@ -61,20 +61,20 @@ public class DynamicFeatureMenuE4 {
         Object selectedElement = selection.getFirstElement();
 
         if (selectedElement instanceof DescriptionBase<?>) {
-            FeatureTree<?> featureTree = getFeatureTree((DescriptionBase<?>) selectedElement);
+            TermTree<?> featureTree = getFeatureTree((DescriptionBase<?>) selectedElement);
 
-            for (FeatureNode<?> childNode : featureTree.getRootChildren()) {
+            for (TermNode<?> childNode : featureTree.getRootChildren()) {
                 createMenuItem(menu, childNode.getTerm(), globalLanguage);
             }
         } else if (selectedElement instanceof FeatureNodeContainer) {
-            FeatureNode<?> featureNode = ((FeatureNodeContainer) selectedElement)
+            TermNode<?> featureNode = ((FeatureNodeContainer) selectedElement)
                     .getFeatureNode();
 
             // add the feature to the menu
             createMenuItem(menu, featureNode.getTerm(), globalLanguage);
 
             // add possible children to the menu
-            for (FeatureNode<?> childNode : featureNode.getChildNodes()) {
+            for (TermNode<?> childNode : featureNode.getChildNodes()) {
                 createMenuItem(menu, childNode.getTerm(), globalLanguage);
             }
         } else if (selectedElement instanceof DescriptionElementBase) {
@@ -123,8 +123,8 @@ public class DynamicFeatureMenuE4 {
 	 * @param description
 	 * @return
 	 */
-	private FeatureTree<?> getFeatureTree(DescriptionBase description) {
-		FeatureTree<?> featureTree = null;
+	private TermTree<?> getFeatureTree(DescriptionBase description) {
+		TermTree<?> featureTree = null;
 
 		// TODO change this to the feature tree associated with this taxon
 		// description
@@ -138,11 +138,11 @@ public class DynamicFeatureMenuE4 {
 
 		if (featureTree == null) {
 		    featureTree = TermEditorInput.getDefaultFeatureTree();
-		    		}
+		}
 		if (description instanceof TaxonNameDescription){
 		    List<Feature> terms = CdmStore.getTermManager().getPreferredTerms(CdmStore.getService(IVocabularyService.class).load(VocabularyEnum.NameFeature.getUuid()));
 		    terms.remove(Feature.PROTOLOGUE());
-		    featureTree = FeatureTree.NewInstance(terms);
+		    featureTree = TermTree.NewInstance(terms);
 		}
 
 		return featureTree;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/DatabaseRepairUpdateSortIndicesWizard.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/DatabaseRepairUpdateSortIndicesWizard.java
index 9b6079f9f..ea9863932 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/DatabaseRepairUpdateSortIndicesWizard.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/DatabaseRepairUpdateSortIndicesWizard.java
@@ -25,7 +25,6 @@ import eu.etaxonomy.taxeditor.store.CdmStore;
 /**
  * @author k.luther
  * @date 06.12.2016
- *
  */
 public class DatabaseRepairUpdateSortIndicesWizard extends Wizard implements IPostMoniteredOperationEnabled{
    // private final DatabaseRepairSortIndexPage repairSortIndexPage;
@@ -51,12 +50,10 @@ public class DatabaseRepairUpdateSortIndicesWizard extends Wizard implements IPo
             if (config == null){
                 ICdmSource source= CdmStore.getActiveCdmSource();
                 config = SortIndexUpdaterConfigurator.NewInstance();
-                config.setDoFeatureNode(false);
+                config.setDoTermNode(false);
                 config.setDoPolytomousKeyNode(false);
-
-
              }
-            if (config.isDoFeatureNode() || config.isDoPolytomousKeyNode() || config.isDoTaxonNode()){
+            if (config.isDoTermNode() || config.isDoPolytomousKeyNode() || config.isDoTaxonNode()){
 
                 final UUID uuid = longRunningTaskService.monitLongRunningTask(config);
                 Display.getDefault().asyncExec(new Runnable() {
@@ -69,15 +66,10 @@ public class DatabaseRepairUpdateSortIndicesWizard extends Wizard implements IPo
                                 DatabaseRepairUpdateSortIndicesWizard.this,
                                 null,
                                 true);
-
                     }
-
                 });
-
-
             }
 
-
         return true;
     }
 
@@ -92,8 +84,5 @@ public class DatabaseRepairUpdateSortIndicesWizard extends Wizard implements IPo
     @Override
     public void postOperation(IRemotingProgressMonitor monitor) {
         // TODO Auto-generated method stub
-
     }
-
-
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/SortIndexUpdaterWizardPage.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/SortIndexUpdaterWizardPage.java
index f934b8928..048431470 100755
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/SortIndexUpdaterWizardPage.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/databaseAdmin/wizard/SortIndexUpdaterWizardPage.java
@@ -68,14 +68,14 @@ public class SortIndexUpdaterWizardPage extends WizardPage {
         });
 
         Button checkBoxFeatureNode = new Button(composite, SWT.CHECK);
-        checkBoxFeatureNode.setSelection(sortIndexConfig.isDoFeatureNode());
+        checkBoxFeatureNode.setSelection(sortIndexConfig.isDoTermNode());
         checkBoxFeatureNode.setText(Messages.DatabaseRepairPage_featureNodes);
         checkBoxFeatureNode
         .setToolTipText(Messages.DatabaseRepairPage_toolTipFeatureNodes);
         checkBoxFeatureNode.addSelectionListener(new SelectionAdapter() {
             @Override
             public void widgetSelected(SelectionEvent e) {
-                sortIndexConfig.setDoFeatureNode(!sortIndexConfig.isDoFeatureNode());
+                sortIndexConfig.setDoTermNode(!sortIndexConfig.isDoTermNode());
             }
         });
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/FeatureTreeViewerComparator.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/FeatureTreeViewerComparator.java
index 8a068f761..864bff11c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/FeatureTreeViewerComparator.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/editor/definedterm/FeatureTreeViewerComparator.java
@@ -12,20 +12,19 @@ package eu.etaxonomy.taxeditor.editor.definedterm;
 import org.eclipse.jface.viewers.Viewer;
 import org.eclipse.jface.viewers.ViewerComparator;
 
-import eu.etaxonomy.cdm.model.term.FeatureTree;
+import eu.etaxonomy.cdm.model.term.TermTree;
 
 /**
  *
  * @author pplitzner
  * @since May 24, 2019
- *
  */
 public class FeatureTreeViewerComparator extends ViewerComparator {
 
     @Override
     public int compare(Viewer viewer, Object e1, Object e2) {
-        if(e1 instanceof FeatureTree && e2 instanceof FeatureTree) {
-            return ((FeatureTree)e1).getTitleCache().toLowerCase().compareTo(((FeatureTree) e2).getTitleCache().toLowerCase());
+        if(e1 instanceof TermTree && e2 instanceof TermTree) {
+            return ((TermTree<?>)e1).getTitleCache().toLowerCase().compareTo(((TermTree<?>) e2).getTitleCache().toLowerCase());
         }
         return super.compare(viewer, e1, e2);
     }
